%global debug_package   %{nil}
%global provider        github
%global provider_tld    com
%global project         mitchellh
%global repo            mapstructure
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          740c764bc6149d3f1806231418adb9f52c11bcbf
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

# temporary mitchellh-cli
%global t_repo            cli
%global t_import_path     %{provider}.%{provider_tld}/%{project}/%{t_repo}
%global t_commit          afc399c273e70173826fb6f518a48edff23fe897
%global t_shortcommit     %(c=%{t_commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0
Release:        0.4.git%{shortcommit}%{?dist}
Summary:        Go library for decoding generic map values into native Go structures
License:        MIT
URL:            https://%{import_path}
Source0:        https://%{import_path}/archive/%{commit}/%{t_repo}-%{t_shortcommit}.tar.gz
Source1:        https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
BuildArch:      noarch
%else
ExclusiveArch:  %{ix86} x86_64 %{arm}
%endif

%description
mapstructure is a Go library for decoding generic map values to structures
and vice versa, while providing helpful error handling.

This library is most useful when decoding values from some data stream (JSON,
Gob, etc.) where you don't quite know the structure of the underlying data
until you read a part of it. You can therefore read a map[string]interface{}
and use this library to decode it into the proper underlying
native Go structure.

%package devel
BuildRequires:  golang >= 1.2.1-3
Summary:        %{summary}
Provides:       golang(%{import_path}) = %{version}-%{release}

%description devel
mapstructure is a Go library for decoding generic map values to structures
and vice versa, while providing helpful error handling.

This library is most useful when decoding values from some data stream (JSON,
Gob, etc.) where you don't quite know the structure of the underlying data
until you read a part of it. You can therefore read a map[string]interface{}
and use this library to decode it into the proper underlying
native Go structure.

This package contains library source intended for 
building other packages which use %{project}/%{repo}.

# remove this package once golang-github-mitchellh-cli is built
%package -n golang-github-mitchellh-cli-devel-temporary
Summary: golang-github-mitchellh-cli source codes temporary
BuildRequires: golang >= 1.2.1-3
BuildRequires: golang(golang.org/x/crypto/ssh/terminal)
Requires:      golang(golang.org/x/crypto/ssh/terminal)


%description -n golang-github-mitchellh-cli-devel-temporary
Temporary devel subpackage for golang-github-mitchellh-cli source codes

%prep
%setup -q -n %{t_repo}-%{t_commit}
%setup -q -n %{repo}-%{commit} -T -b 1

%build

%install
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
cp -pav *.go %{buildroot}/%{gopath}/src/%{import_path}/
pushd ../%{t_repo}-%{t_commit}
install -d -p %{buildroot}/%{gopath}/src/%{t_import_path}/
# copy directories
cp -pav *.go %{buildroot}%{gopath}/src/%{t_import_path}/

%check
# sometimes tests pass, sometimes not, probably due to unordered list expected to be ordered
#GOPATH={buildroot}/{gopath}:{gopath} go test {import_path}

%files devel
%doc README.md LICENSE
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%dir %{gopath}/src/%{import_path}/
%{gopath}/src/%{import_path}/*.go

%files -n golang-github-mitchellh-cli-devel-temporary
%if 0%{?fedora}
%license LICENSE
%doc README.md
%else
%doc README.md LICENSE
%endif
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%{gopath}/src/%{t_import_path}

%changelog
* Fri Oct 17 2014 jchaloup <jchaloup@redhat.com> - 0-0.4.git740c764
- Choose the correct architecture
- Update license
- Remove runtime-dep on golang
- Add temporary devel subpackage of mitchellh-cli
  resolves: #1243892

* Thu Oct 16 2014 jchaloup <jchaloup@redhat.com> - 0-0.1.git740c764
- First package for Fedora
  resolves: #1153724

